<template>
    <q-list>
        <q-item-label header>Worker Settings</q-item-label>
        <ToggleSetting label="Draw Workers"
                       caption="Whether to show worker locations"
                       v-model="FloorPlanSettings.StoreValue.showWorkers"
        />
        <SliderSetting
            label="Worker Size"
            caption="Worker Label Shape's size"
            v-model="FloorPlanSettings.StoreValue.workerDotSize"
            :disable="!ShowWorker"
            :min="4" :max="100" :step="4"
        />
        <RadioSetting label="Label Shape"
                      caption="Shape to represent workers on the floorplan"
                      :disable="!ShowWorker"
                      :options="LabelType"
                      v-model="FloorPlanSettings.StoreValue.workerLabelShape"

        />
        <RadioSetting
            label="Label Mode"
            caption="How to name the workers on the floorplan"
            :disable="!ShowWorker"
            :options="LabelMode"
            v-model="FloorPlanSettings.StoreValue.workerLabelMode"
        />
        <ToggleSetting
            :disabled="!ShowWorker"
            label="Hide Inactive"
            caption="Do not show workers that are inactive"
            v-model="FloorPlanSettings.StoreValue.workerDisplayInactive"
        />
        <ToggleSetting
            :disabled="!ShowWorker"
            label="Pulse Worker Labels"
            caption="Make worker labels emit pulses"
            v-model="FloorPlanSettings.StoreValue.pulse"
        />
        <SliderSetting
            label="Inactive Duration"
            caption="The number of minutes after which a worker has not been detected in minutes to be considered 'inactive'"
            :disable="!ShowWorker"
            v-model="FloorPlanSettings.StoreValue.workerInactiveDuration"
            :step="4"
            :min="2" :max="30"
        />
        <SliderSetting
            label="Label Text Size"
            :disable="!ShowText"
            caption="Size of the worker's label text"
            v-model="FloorPlanSettings.StoreValue.workerLabelSize"
            :min="4" :max="100" :step="4"
        />
        <ColorSetting
            label="Label Text Color"
            :disable="!ShowText"
            caption="Color of the worker's label text"
            v-model="FloorPlanSettings.StoreValue.workerLabelColor"
        />

        <ColorSetting
            label="Label Text Background"
            :disable="!ShowText"
            caption="Color of the worker's label text background"
            v-model="FloorPlanSettings.StoreValue.workerLabelBackgroundColor"
        />

        <SliderSetting
            label="Label Text Opacity"
            :disable="!ShowText"
            caption="Color of the worker's label text background's opacity"
            v-model="FloorPlanSettings.StoreValue.workerLabelBackgroundTransparency"
            :min="0" :max="1" :step="0.05"
        />
        <SliderSetting
            label="Label Border Size"
            :disable="!ShowText"
            caption="Thickness of the worker's label text's border"
            v-model="FloorPlanSettings.StoreValue.workerLabelBorderSize"
            :min="0" :max="5" :step="0.5"
        />
        <ColorSetting
            label="Label Border Color"
            :disable="!ShowText"
            caption="Worker's label text's border's color"
            v-model="FloorPlanSettings.StoreValue.workerLabelBorderColor"
        />
    </q-list>
</template>

<script lang='ts'>
import {Component, Vue} from 'vue-property-decorator';
import ToggleSetting from "components/Filters/ToggleSetting.vue";
import SliderSetting from "components/Filters/SliderSetting.vue";
import RadioSetting from "components/Filters/RadioSetting.vue";
import {WorkerLabelType} from "src/classLibrary/Constants";
import {WorkerLabelMode} from "src/classLibrary/Geometry/ShapeDrawer";
import ColorSetting from "components/Filters/ColorSetting.vue";

@Component({
    components: {ColorSetting, RadioSetting, SliderSetting, ToggleSetting}
})
export default class WorkerSettings extends Vue {

    get ShowWorker() {
        return this.FloorPlanSettings.StoreValue.showWorkers;
    }

    get LabelType() {
        return WorkerLabelType
    }

    get ShowText() {
        return this.FloorPlanSettings.StoreValue.workerLabelMode !== 'none' && this.ShowWorker;
    }

    get LabelMode(): { label: string, value: WorkerLabelMode, description: string }[] {
        return [
            {
                label: 'None',
                value: 'none',
                description: 'Remove names from labels'
            },
            {
                label: 'Name',
                value: 'name',
                description: 'Use the name of the workers'
            },
            {
                label: 'Short Name',
                value: 'name-short',
                description: `Use the first 3 characters of the worker's name`
            },
            {
                label: 'ID',
                value: 'id',
                description: `Worker's registered UUID (Unique Identifier) on Builderlytics`,
            },
            {
                label: 'Short ID',
                value: 'id-short',
                description: `First 3 character's Worker's registered UUID (Unique Identifier) on Builderlytics`,
            }
        ]
    }

}
</script>

<style lang='scss' scoped>

</style>
